/** 
 * TestDates Program Variant D, with JUnit 3.8. test cases
 *
 * @author Uwe Aßmann
 * The parsing of date strings is a case analysis; many different countries have different
 * date formats, so every country in which the software shall be sold, generates
 * a case (internationalization). In big Enterprise Software frameworks, dates
 * are big classes with a lot of code!
 */

import java.lang.*;  // Integer
import java.lang.reflect.*;  // Method
import java.util.*;
import java.util.zip.DataFormatException;

// JUnit 3.8.X; be careful, it should be listed in the CLASSPATH environment variable
import junit.framework.*;

public class TestDateD {
    // Main program. 
    public static void main(String args[]) {
	TestSuite suite = new TestSuite();
	TestResult result = new TestResult();
	TestGermanDates testcaseG = new TestGermanDates("testGerman");
	System.out.println("testcaseG: "+testcaseG.toString()); 
	TestGermanDates testcaseG2 = new TestGermanDates("testGerman2");
	System.out.println("testcaseG2: "+testcaseG2.toString()); 
 	TestEnglishDates testcaseE = new TestEnglishDates("testEnglish");
 	System.out.println("testcaseE: "+testcaseE.toString()); 

 	suite.addTest(testcaseG);
 	suite.addTest(testcaseG2);
  	suite.addTest(testcaseE);
	// run tests
 	System.out.println("We have "+suite.countTestCases()+" test cases with "+suite.testCount()+" tests"); 
 	System.out.println("****************************************************"); 

	// Run the constructed test suite
 	suite.run(result); 
// 	testcaseG.run(result);
 //	testcaseG2.run(result);

 	System.out.println("****************************************************"); 
	System.out.println("errors:"+result.errorCount());
	for (Enumeration e = (Enumeration)result.errors(); 
	     e.hasMoreElements();) {
	    System.out.println(e.nextElement().toString());
	}
 	System.out.println("****************************************************"); 
	System.out.println("failures:"+result.failureCount());
	for (Enumeration e = (Enumeration)result.failures(); 
	     e.hasMoreElements();) {
	    System.out.println(e.nextElement().toString());
	}
    }
}

