/** 
 * Dates, with JUnit 4.4. test cases
 *
 * @author Uwe Aßmann
 * The parsing of date strings is a case analysis; many different countries have different
 * date formats, so every country in which the software shall be sold, generates
 * a case (internationalization). In big Enterprise Software frameworks, dates
 * are big classes with a lot of code!
 * 
 * To be run with:
 * $  setenv CLASSPATH=$CLASSPATH:$JUNITPATH/junit4.4/junit-4.4.jar
 * $ java org.junit.runner.JUnitCore TestGermanDatesJUnit4
 */

import java.lang.*;  // Integer
import java.lang.reflect.*;  // Method
import java.util.*;
import java.util.zip.DataFormatException;

// JUnit 4.1-10 must be used, it should be listed in the CLASSPATH environment variable
import org.junit.*;
// assertEquals must be imported from Class Assert
import static org.junit.Assert.*;

public class TestGermanDatesJUnit4 /* no superclass necessary */ {
    // Fixture
    static DateD date;
    static DateD date2;
    static DateD date3;
    int result;
    
    @BeforeClass public static void setUp ()  {
	date = new DateD();
	date2 = new DateD();
	date3 = new DateD();
    }

    /**
     * This example method is full of traps for the execution with the
     * JUnit runner. Please experiment to get it right.
     */
    @Test public void german() {
	System.out.println("Date parsed: Day/Month/Year:"+date.day+":"+date.month+":"+date.year);
	try {
	    // run tests
	    result = date.parseDate("01.30.2013"); 
	    System.out.println("Date parsed: Day/Month/Year:"+date.day+":"+date.month+":"+date.year);
	    assertEquals("1:",date.day,1); // from Assert
	    assertEquals("2:",date.month,10);  // faiure
	    assertEquals("3:",date.year,2013);
	    
	    result = date2.parseDate("02. 11. 2014"); 
	    System.out.println("Date parsed: Day/Month/Year:"+date.day+":"+date.month+":"+date.year);
	    assertEquals(date2.day,2);
	    assertEquals(date2.month,11);
	    assertEquals(date2.year,2014);
	    
	    result = date3.parseDate("12.31.15"); 
	    System.out.println("Date parsed: Day/Month/Year:"+date.day+":"+date.month+":"+date.year);
	    assertEquals("7:",date.day,12);  // bug!
	    assertEquals("8:",date.month,30);  // bug and failure!
	    assertEquals("9:",date.year,2015);  // bug!
	} catch (DataFormatException ex) {
	    System.out.println("TestGermanDatesJUnit4 failed on "+ex.toString());
	}
    }
    @Test public void german2() {
	try {
	    // run tests
	    result = date3.parseDate("12.31.2019"); 
	    System.out.println("Date parsed: Day/Month/Year:"+date.day+":"+date.month+":"+date.year);
	} catch (DataFormatException ex) {
	    System.out.println("TestGermanDatesJUnit4 failed on "+ex.toString());
	}
    }
    // no tear down necessary
}

